import axios, { Method, ResponseType } from "axios";

const BASEURL = process.env.NODE_ENV === "development" ? "/api" : "/chatapi";

interface responseData {
  error_code?: number;
  data: any;
  message: string;
}

// 网络请求
export default function fetch(
  uri: string,
  data: object,
  method: Method = "POST",
  responseType: ResponseType = "json",
  headers: object = {}
) {
  return new Promise<responseData>((resolve, reject) => {
    axios({
      url: BASEURL + uri,
      method: method,
      params: ["GET", "DELETE"].includes(method) ? data : null,
      data: ["POST", "PUT"].includes(method) ? data : null,
      headers: headers,
      responseType: responseType,
      timeout: 5 * 60 * 1000,
    }).then(function (response) {
      resolve(response.data);
    });
  });
}
