var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import BaseController from "./BaseController.js";
import { Configuration, OpenAIApi } from "openai";
import HttpsProxyAgent from "https-proxy-agent";
import config from "../../config/config.js";
// 页面
export default class IndexController extends BaseController {
    /*
     * @author lijunjie<2281551151@qq.com>
     * @desc 对话信息
     */
    IndexAction() {
        return __awaiter(this, void 0, void 0, function* () {
            // console.log(this._req.body);
            // this.success("aaaaaaaaa");
            // return;
            const { message } = this._req.body;
            const configuration = new Configuration({
                organization: config.CHATGPT_ORGANIZATION_ID,
                apiKey: config.CHATGPT_APIKEY,
            });
            const openai = new OpenAIApi(configuration);
            const completion = yield openai.createCompletion({
                model: "text-davinci-003",
                prompt: message,
                temperature: 0.9,
                max_tokens: 4000,
                top_p: 1,
                frequency_penalty: 0,
                presence_penalty: 0.6,
            }, {
                proxy: false,
                httpAgent: config.HTTP_PROXY
                    ? HttpsProxyAgent(config.HTTP_PROXY)
                    : undefined,
                httpsAgent: config.HTTPS_PROXY
                    ? HttpsProxyAgent(config.HTTPS_PROXY)
                    : undefined,
            });
            this._res.json({
                code: 200,
                message: "成功",
                data: completion.data.choices[0].text,
            });
        });
    }
}
