var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import fs from "fs";
import path from "path";
// 创建路由
const createRouter = (app) => __awaiter(void 0, void 0, void 0, function* () {
    // 读取模块
    const modulesTasks = fs
        .readdirSync(path.resolve("./src/Modules"))
        .map((moduleName) => __awaiter(void 0, void 0, void 0, function* () {
        return ({
            moduleName,
            module: yield import(`./Modules/${moduleName}/module.js`),
        });
    }));
    let modules = yield Promise.all(modulesTasks);
    app.all("*", (_req, _res, next) => {
        console.log("用户访问:", _req.url, "请求方法:", _req.method);
        next();
    });
    // 自动注册路由
    for (let m in modules) {
        for (let c in modules[m].module.default) {
            let actions = Object.getOwnPropertyNames(modules[m].module.default[c].prototype).filter((item) => !["constructor"].includes(item));
            let controllerName = c.split("Controller")[0];
            actions.forEach((item) => {
                // 网站路径
                let path = `/${modules[m]["moduleName"]}/${controllerName}/${item.split("Action")[0]}`.toLowerCase();
                app.all(path, (_req, _res) => {
                    new modules[m].module.default[c](_req, _res)[item]();
                });
            });
        }
    }
    // 默认首页
    app.all("/", (_req, _res) => {
        new modules[0].module.default.IndexController(_req, _res)["IndexAction"]();
    });
});
export default createRouter;
