import BaseController from "./BaseController.js";
import { Configuration, OpenAIApi } from "openai";
import HttpsProxyAgent from "https-proxy-agent";
import config from "../../config/config.js";

// 页面
export default class IndexController extends BaseController {
  /*
   * @author lijunjie<2281551151@qq.com>
   * @desc 对话信息
   */
  public async IndexAction() {
    // console.log(this._req.body);
    // this.success("aaaaaaaaa");
    // return;

    const { message } = this._req.body;

    const configuration = new Configuration({
      organization: config.CHATGPT_ORGANIZATION_ID,
      apiKey: config.CHATGPT_APIKEY,
    });
    const openai = new OpenAIApi(configuration);

    const completion = await openai.createCompletion(
      {
        model: "text-davinci-003",
        prompt: message,
        temperature: 0.9,
        max_tokens: 4000, // 最大长度
        top_p: 1,
        frequency_penalty: 0,
        presence_penalty: 0.6,
      },
      {
        proxy: false,
        httpAgent: config.HTTP_PROXY
          ? HttpsProxyAgent(config.HTTP_PROXY)
          : undefined,
        httpsAgent: config.HTTPS_PROXY
          ? HttpsProxyAgent(config.HTTPS_PROXY)
          : undefined,
      }
    );

    this._res.json({
      code: 200,
      message: "成功",
      data: completion.data.choices[0].text,
    });
  }
}
