import express from "express";
import createRouter from "./router.js";
import bodyParser from "body-parser";
import config from "./config/config.js";

// 实例化
const app: express.Application = express();

// extended:false代表方法内部使用querystring模块处理请求
app.use(bodyParser.json());
app.use(bodyParser.urlencoded({ extended: false }));

// 路由
createRouter(app);

app.listen(config.APP_PORT, config.APP_HOST, () => {
  console.log(
    `TypeScript with Express http://${config.APP_HOST}:${config.APP_PORT}/`
  );
});
